var Util = require("./Util")
var CurrentMetadata = null
var Module = {}
var SOCIAL_MEDIA = process.env.SOCIAL_MEDIA
var ROLE = process.env.ROLE || "slave"
var MASTER_PORT = process.env.MASTER_PORT || 59221
process.env.MASTER_PORT = MASTER_PORT
process.env.ROLE = ROLE
function getPort(){
	return ROLE == "master" ? MASTER_PORT : Util.getRandomPortNumber()
}

function getMetadata(force){
	if(!CurrentMetadata || force){
		CurrentMetadata = {
			ip_address : Util.getExtIp(),
			port : getPort(),
			role : ROLE,
			social_media : process.env.SOCIAL_MEDIA,			
			crawler_type : process.env.CRAWLER_TYPE,
			slave_type : process.env.SLAVE_TYPE,
			bind_all_interfaces : true
		}
	}

	return CurrentMetadata
}
Module.getMetadata = getMetadata
module.exports = Module