var Module = {}
var OS = require("os")
var underscore = require("underscore")
var networkInterfaces = OS.networkInterfaces()
var MIN_PORT = 40000
var MAX_PORT = 50000

function getExtIp(){
	var selectedAddress = ""
	underscore.each(networkInterfaces,function(addressList){
		underscore.each(addressList,function(adressItem){
			var family = adressItem.family
			var internal = adressItem.internal
			var address = adressItem.address
			if( family.toLowerCase() == "ipv4" && address.indexOf("192.") != 0 && !internal && address.indexOf("10.") != 0){
				selectedAddress = address
			}
		})
	})
	if ( !selectedAddress ) throw new Error("External IP Address that belongs to IPv4 is not found!")
	return selectedAddress
}

function getRandomPortNumber(){
	var randomSeed = Math.random() * (MAX_PORT - MIN_PORT)
	var basePort = MIN_PORT + randomSeed
	return basePort.toFixed(0)
}

Module.getExtIp = getExtIp
Module.getRandomPortNumber = getRandomPortNumber

module.exports = Module