var Agent = require("../index")
var MessageDef = Agent.MessageDef
var EventEmitter = new (require("events").EventEmitter)()
var Assignment = null
Agent
.onAgentSuicide(function() {
	Assignment = null
	EventEmitter.emit("drop")
})
.on("JobDropAssignment",function(){
	console.log("Receive assignment drop!")
	Assignment = null
	EventEmitter.emit("drop")
})
.on("AskAssignment",function(message,responder){
	responder( new MessageDef.Reply( Assignment ))
})
.on("CrawlerAssignment",function(message){
	Assignment  = message	
	EventEmitter.emit("assignment", {
		priority : Assignment.priority,
		partition : Assignment.partition,
		user : Assignment.user,
		pool_address : Assignment.poolAddress,
		output_dir : Assignment.outputDir,
		crawler_type : Assignment.crawlerType
	})
})
function onAssignmentReady( fn ) {
	EventEmitter.on("assignment", fn )
	return this
}
function onAssignmentDrop( fn ) {
	EventEmitter.on("drop", fn )
	return this
}

Agent.onAssignmentDrop = onAssignmentDrop
Agent.onAssignmentReady = onAssignmentReady
module.exports = Agent